//
//  MainPanel.java
//  Red Queen Simulator
//
//  Created by John Damuth on Thu Jan 27 2005.
//  Copyright (c) 2005-2007 Pantherion Corporation. All rights reserved.
//  Version 1.5

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import java.io.*;
import java.util.*;
import java.net.URL;
import java.lang.*;


public class MainPanel extends JFrame 
{

	// member declarations
	javax.swing.JSlider TimestepsSlider = new javax.swing.JSlider();
	javax.swing.JToggleButton VideoModeSwitch = new javax.swing.JToggleButton();
	javax.swing.JToggleButton AnalysisModeSwitch = new javax.swing.JToggleButton();
	DefaultCRT CRT = new DefaultCRT(new java.awt.Dimension(300, 260),VideoModeSwitch, AnalysisModeSwitch);
	javax.swing.JToggleButton PowerSwitch = new javax.swing.JToggleButton();
	javax.swing.JSlider FaunasSlider = new javax.swing.JSlider();
	javax.swing.JSlider SpeciesSlider = new javax.swing.JSlider(1,500,120);
	javax.swing.JSlider EtotSlider = new javax.swing.JSlider(1,10,7);
	javax.swing.JLabel EtotLabel = new javax.swing.JLabel();
	javax.swing.JLabel EtotNumberLabel = new javax.swing.JLabel();
	javax.swing.JToggleButton HardcapSwitch = new javax.swing.JToggleButton();
	javax.swing.JLabel HardcapLabel = new javax.swing.JLabel();
	javax.swing.JLabel HardcapOn = new javax.swing.JLabel();
	javax.swing.JLabel HardcapOff = new javax.swing.JLabel();
	javax.swing.JToggleButton PoolVarSwitch = new javax.swing.JToggleButton();
	javax.swing.JLabel PoolVarLabel = new javax.swing.JLabel();
	javax.swing.JLabel PoolVarOn = new javax.swing.JLabel();
	javax.swing.JLabel PoolVarOff = new javax.swing.JLabel();
	javax.swing.JSlider YvarianceSlider = new javax.swing.JSlider();
	javax.swing.JSlider MaxSlopeSlider = new javax.swing.JSlider();
	javax.swing.JSlider MinSlopeSlider = new javax.swing.JSlider();
	javax.swing.JSlider AcquisitionSlider = new javax.swing.JSlider();
	javax.swing.JSlider BasePFSlider = new javax.swing.JSlider();
	javax.swing.JToggleButton UniverseSwitch = new javax.swing.JToggleButton();
	javax.swing.JToggleButton MinimumSwitch = new javax.swing.JToggleButton();
	javax.swing.JToggleButton EXSwitch = new javax.swing.JToggleButton();
	javax.swing.JToggleButton EValueSwitch = new javax.swing.JToggleButton();
	javax.swing.JLabel TimestepNumberLabel = new javax.swing.JLabel();
	javax.swing.JLabel TimestepsLabel = new javax.swing.JLabel();
	javax.swing.JLabel jLabel3 = new javax.swing.JLabel();
	javax.swing.JLabel PantherionLabel = new javax.swing.JLabel();
	javax.swing.JLabel PowerLight = new javax.swing.JLabel();
	javax.swing.JSlider PFSlopeSlider = new javax.swing.JSlider();
	javax.swing.JSlider EnergySlider = new javax.swing.JSlider();
	javax.swing.JSlider AdvancingSlider = new javax.swing.JSlider();
	javax.swing.JSlider CompetitionSlider = new javax.swing.JSlider();
	javax.swing.JSlider ExtinctionLimitSlider = new javax.swing.JSlider();
	javax.swing.JLabel FaunasLabel = new javax.swing.JLabel();
	javax.swing.JLabel FaunasNumberLabel = new javax.swing.JLabel();
	javax.swing.JLabel Ylabel = new javax.swing.JLabel();
	javax.swing.JLabel YnumberLabel = new javax.swing.JLabel();
	javax.swing.JLabel SpeciesLabel = new javax.swing.JLabel();
	javax.swing.JLabel SSpeciesNumberLabel = new javax.swing.JLabel();
	javax.swing.JLabel MaxSlopeLabel = new javax.swing.JLabel();
	javax.swing.JLabel MaxSlopeNumberLabel = new javax.swing.JLabel();
	javax.swing.JLabel MinSlopeLabel = new javax.swing.JLabel();
	javax.swing.JLabel MinSlopeNumberLabel = new javax.swing.JLabel();
	javax.swing.JLabel AcquisitionLabel = new javax.swing.JLabel();
	javax.swing.JLabel AcquisitionNumberLabel = new javax.swing.JLabel();
	javax.swing.JLabel BasePFLabel = new javax.swing.JLabel();
	javax.swing.JLabel BasePFNumberLabel = new javax.swing.JLabel();
	javax.swing.JLabel PFSlopeLabel = new javax.swing.JLabel();
	javax.swing.JLabel PFSlopeNumberLabel = new javax.swing.JLabel();
	javax.swing.JLabel ExtinctionLabel = new javax.swing.JLabel();
	javax.swing.JLabel ExtinctionNumberLabel = new javax.swing.JLabel();
	javax.swing.JLabel CompetitionLabel = new javax.swing.JLabel();
	javax.swing.JLabel CompetitionNumberLabel = new javax.swing.JLabel();
	javax.swing.JLabel AdvancingLabel = new javax.swing.JLabel();
	javax.swing.JLabel AdvancingNumberLabel = new javax.swing.JLabel();
	javax.swing.JLabel EnergyLabel = new javax.swing.JLabel();
	javax.swing.JLabel EnergyNumberLabel = new javax.swing.JLabel();
	javax.swing.JLabel univSwLabel = new javax.swing.JLabel();
	javax.swing.JLabel jLabel28 = new javax.swing.JLabel();
	javax.swing.JLabel jLabel29 = new javax.swing.JLabel();
	javax.swing.JLabel jLabel30 = new javax.swing.JLabel();
	javax.swing.JLabel modeLabel = new javax.swing.JLabel();
	javax.swing.JLabel amLabel = new javax.swing.JLabel();
	javax.swing.JLabel jLabel31 = new javax.swing.JLabel();
	javax.swing.JLabel voltageLabel = new javax.swing.JLabel();
	javax.swing.JLabel openLabel = new javax.swing.JLabel();
	javax.swing.JLabel closedLabel = new javax.swing.JLabel();
	javax.swing.JButton StartButton = new javax.swing.JButton();
	javax.swing.JButton SaveButton = new javax.swing.JButton();
	javax.swing.JButton StopButton = new javax.swing.JButton();
	javax.swing.JLabel jLabel32 = new javax.swing.JLabel();
	javax.swing.JLabel jLabel33 = new javax.swing.JLabel();
	javax.swing.JLabel jLabel34 = new javax.swing.JLabel();
	javax.swing.JLabel jLabel35 = new javax.swing.JLabel();
	javax.swing.JLabel jLabel36 = new javax.swing.JLabel();
	javax.swing.JLabel jLabel37 = new javax.swing.JLabel();
	javax.swing.JLabel RunningLight = new javax.swing.JLabel();
	javax.swing.JLabel KleiberLabel = new javax.swing.JLabel();
	javax.swing.JLabel KleiberNumberLabel = new javax.swing.JLabel();
	javax.swing.JSlider KleiberSlider = new javax.swing.JSlider();

	ImageIcon switch_off;
	ImageIcon switch_on;
	ImageIcon pantherion;
	ImageIcon light_off;
	ImageIcon light_on_red;
	ImageIcon light_on_green;
	ImageIcon startB;
	ImageIcon stopB;
	ImageIcon saveB;
	ImageIcon startoffB;
	ImageIcon saveoffB;
	ImageIcon stopoffB;
		
	boolean universe_open = false;
	boolean minimum_is_density = true;
	boolean exchange_proportional = true;
	boolean evalue_random = true;
	boolean slope_view = true;
	boolean points_view = false;
	boolean seud_view = false;
	boolean sd_view = false;
	boolean analysis_on = false;
	boolean hard_cap_open = true;
	boolean poolvar_is_constant = true;
	
	boolean	should_execute = true;
			
	public MainPanel()
	{
	getContentPane().setBackground(Color.black);
	}

	public void initComponents() throws Exception
	{
	

		// Get images from the .jar file
		switch_off = new ImageIcon(new URL("jar:file:RQSimulator.jar/!/switchoff.jpg"));
		switch_on = new ImageIcon(new URL("jar:file:RQSimulator.jar/!/switchon.jpg"));
		pantherion = new ImageIcon(new URL("jar:file:RQSimulator.jar/!/pantherion.jpg"));
		light_off = new ImageIcon(new URL("jar:file:RQSimulator.jar/!/lightoff.jpg"));
		light_on_red = new ImageIcon(new URL("jar:file:RQSimulator.jar/!/lightonRed.jpg"));
		light_on_green = new ImageIcon( new URL("jar:file:RQSimulator.jar/!/lightonGreen.jpg"));
		startB = new ImageIcon( new URL("jar:file:RQSimulator.jar/!/start.jpg"));
		stopB = new ImageIcon( new URL("jar:file:RQSimulator.jar/!/stop.jpg"));
		saveB = new ImageIcon( new URL("jar:file:RQSimulator.jar/!/save.jpg"));
		startoffB = new ImageIcon( new URL("jar:file:RQSimulator.jar/!/startoff.jpg"));
		saveoffB = new ImageIcon( new URL("jar:file:RQSimulator.jar/!/saveoff.jpg"));
		stopoffB = new ImageIcon( new URL("jar:file:RQSimulator.jar/!/stopoff.jpg"));
			
		PantherionLabel.setIcon(pantherion);
		
		PowerSwitch.setIcon(switch_off);
		UniverseSwitch.setIcon(switch_off);
		HardcapSwitch.setIcon(switch_on);
		PoolVarSwitch.setIcon(switch_on);
		MinimumSwitch.setIcon(switch_on);
		EXSwitch.setIcon(switch_on);
		EValueSwitch.setIcon(switch_on);
		VideoModeSwitch.setIcon(switch_off);
		VideoModeSwitch.setEnabled(false);
		AnalysisModeSwitch.setIcon(switch_off);
		AnalysisModeSwitch.setEnabled(false);
		
		PowerLight.setIcon(light_off);
		RunningLight.setIcon(light_off);
		
		

		// The following code sets the frame's initial state
		//  and initializes all of the controls

		TimestepsSlider.setForeground(new java.awt.Color(255, 255, 255));
		TimestepsSlider.setLocation(new java.awt.Point(40, 320));
		TimestepsSlider.setVisible(true);
		TimestepsSlider.setMinimum(1);
		TimestepsSlider.setBackground(new java.awt.Color(0, 0, 0));
		TimestepsSlider.setValue(30);
		TimestepsSlider.setMaximum(10000);
		TimestepsSlider.setPaintTicks(true);
		TimestepsSlider.setSize(new java.awt.Dimension(120, 30));
		TimestepsSlider.setMajorTickSpacing(500);
		TimestepsSlider.setToolTipText("Number of timesteps each fauna will be followed");

		CRT.setLocation(new java.awt.Point(50, 20));
		CRT.setVisible(true);

		PowerSwitch.setMaximumSize(new java.awt.Dimension(28, 35));
		PowerSwitch.setLocation(new java.awt.Point(500, 30));
		PowerSwitch.setContentAreaFilled(false);
		PowerSwitch.setVisible(true);
		PowerSwitch.setBackground(new java.awt.Color(0, 0, 0));
		PowerSwitch.setBorderPainted(false);
		PowerSwitch.setMinimumSize(new java.awt.Dimension(28, 35));
		PowerSwitch.setSize(new java.awt.Dimension(28, 35));
		PowerSwitch.setFocusPainted(false);
		PowerSwitch.setDoubleBuffered(true);
		PowerSwitch.setHorizontalTextPosition(0);
		PowerSwitch.setDisabledIcon(switch_off);
		PowerSwitch.setToolTipText("You have to turn the device on!");

		FaunasSlider.setForeground(new java.awt.Color(255, 255, 255));
		FaunasSlider.setLocation(new java.awt.Point(40, 380));
		FaunasSlider.setVisible(true);
		FaunasSlider.setMinimum(1);
		FaunasSlider.setBackground(new java.awt.Color(0, 0, 0));
		FaunasSlider.setValue(10);
		FaunasSlider.setMaximum(1000);
		FaunasSlider.setPaintTicks(true);
		FaunasSlider.setSize(new java.awt.Dimension(120, 30));
		FaunasSlider.setMajorTickSpacing(100);
		FaunasSlider.setToolTipText("Number of iterations (faunas) that will be run");
		
		SpeciesSlider.setForeground(new java.awt.Color(255, 255, 255));
		SpeciesSlider.setLocation(new java.awt.Point(40, 440));
		SpeciesSlider.setVisible(true);
		SpeciesSlider.setMinimum(1);
		SpeciesSlider.setBackground(new java.awt.Color(0, 0, 0));
		SpeciesSlider.setValue(120);
		SpeciesSlider.setMaximum(500);
		SpeciesSlider.setPaintTicks(true);
		SpeciesSlider.setSize(new java.awt.Dimension(120, 30));
		SpeciesSlider.setMajorTickSpacing(25);
		SpeciesSlider.setToolTipText("Initial number of species in each fauna");	
			
		EtotSlider.setForeground(new java.awt.Color(255, 255, 255));
		EtotSlider.setLocation(new java.awt.Point(400, 440));
		EtotSlider.setVisible(true);
		EtotSlider.setMinimum(1);
		EtotSlider.setBackground(new java.awt.Color(0, 0, 0));
		EtotSlider.setValue(7);
		EtotSlider.setMaximum(20);
		EtotSlider.setPaintTicks(true);
		EtotSlider.setSize(new java.awt.Dimension(120, 30));
		EtotSlider.setMajorTickSpacing(2);
		EtotSlider.setToolTipText("Total amount of energy available to each fauna");
	
		YvarianceSlider.setForeground(new java.awt.Color(255, 255, 255));
		YvarianceSlider.setLocation(new java.awt.Point(220, 320));
		YvarianceSlider.setVisible(true);
		YvarianceSlider.setMaximum(200);
		YvarianceSlider.setBackground(new java.awt.Color(0, 0, 0));
		YvarianceSlider.setValue(25);
		YvarianceSlider.setPaintTicks(true);
		YvarianceSlider.setSize(new java.awt.Dimension(120, 30));
		YvarianceSlider.setMajorTickSpacing(25);
		YvarianceSlider.setToolTipText("Initial variation about the regression for each fauna");
		
		MaxSlopeSlider.setForeground(new java.awt.Color(255, 255, 255));
		MaxSlopeSlider.setLocation(new java.awt.Point(220, 380));
		MaxSlopeSlider.setVisible(true);
		MaxSlopeSlider.setMinimum(-200);
		MaxSlopeSlider.setBackground(new java.awt.Color(0, 0, 0));
		MaxSlopeSlider.setValue(-35);
		MaxSlopeSlider.setPaintTicks(true);
		MaxSlopeSlider.setSize(new java.awt.Dimension(120, 30));
		MaxSlopeSlider.setMajorTickSpacing(25);
		MaxSlopeSlider.setToolTipText("The highest initial slope for a fauna");

		MinSlopeSlider.setForeground(new java.awt.Color(255, 255, 255));
		MinSlopeSlider.setLocation(new java.awt.Point(220, 440));
		MinSlopeSlider.setVisible(true);
		MinSlopeSlider.setMinimum(-200);
		MinSlopeSlider.setBackground(new java.awt.Color(0, 0, 0));
		MinSlopeSlider.setValue(-115);
		MinSlopeSlider.setPaintTicks(true);
		MinSlopeSlider.setSize(new java.awt.Dimension(120, 30));
		MinSlopeSlider.setMajorTickSpacing(25);
		MinSlopeSlider.setToolTipText("The lowest initial slope for a fauna");
		
		AcquisitionSlider.setForeground(new java.awt.Color(255, 255, 255));
		AcquisitionSlider.setLocation(new java.awt.Point(400, 320));
		AcquisitionSlider.setVisible(true);
		AcquisitionSlider.setBackground(new java.awt.Color(0, 0, 0));
		AcquisitionSlider.setValue(10);
		AcquisitionSlider.setMaximum(50);
		AcquisitionSlider.setPaintTicks(true);
		AcquisitionSlider.setSize(new java.awt.Dimension(120, 30));
		AcquisitionSlider.setMajorTickSpacing(10);

		BasePFSlider.setForeground(new java.awt.Color(255, 255, 255));
		BasePFSlider.setLocation(new java.awt.Point(400, 380));
		BasePFSlider.setVisible(true);
		BasePFSlider.setBackground(new java.awt.Color(0, 0, 0));
		BasePFSlider.setValue(0);
		BasePFSlider.setPaintTicks(true);
		BasePFSlider.setSize(new java.awt.Dimension(120, 30));
		BasePFSlider.setMajorTickSpacing(25);

		UniverseSwitch.setLocation(new java.awt.Point(550, 100));
		UniverseSwitch.setContentAreaFilled(false);
		UniverseSwitch.setVisible(true);
		UniverseSwitch.setBackground(new java.awt.Color(0, 0, 0));
		UniverseSwitch.setBorderPainted(false);
		UniverseSwitch.setMinimumSize(new java.awt.Dimension(28, 35));
		UniverseSwitch.setSize(new java.awt.Dimension(28, 35));
		UniverseSwitch.setFocusPainted(false);
		UniverseSwitch.setDoubleBuffered(true);
		UniverseSwitch.setHorizontalTextPosition(0);
		UniverseSwitch.setDisabledIcon(switch_off);
		UniverseSwitch.setToolTipText("None = random walks, Win-Lose = the model's Red Queen interactions");
		
		HardcapSwitch.setLocation(new java.awt.Point(550, 160));
		HardcapSwitch.setContentAreaFilled(false);
		HardcapSwitch.setVisible(true);
		HardcapSwitch.setBackground(new java.awt.Color(0, 0, 0));
		HardcapSwitch.setBorderPainted(false);
		HardcapSwitch.setMinimumSize(new java.awt.Dimension(28, 35));
		HardcapSwitch.setSize(new java.awt.Dimension(28, 35));
		HardcapSwitch.setFocusPainted(false);
		HardcapSwitch.setDoubleBuffered(true);
		HardcapSwitch.setHorizontalTextPosition(0);
		HardcapSwitch.setDisabledIcon(switch_off);
		HardcapSwitch.setToolTipText("For random walks, is total energy limited or not?");

		MinimumSwitch.setLocation(new java.awt.Point(550, 220));
		MinimumSwitch.setContentAreaFilled(false);
		MinimumSwitch.setVisible(true);
		MinimumSwitch.setBackground(new java.awt.Color(0, 0, 0));
		MinimumSwitch.setBorderPainted(false);
		MinimumSwitch.setMinimumSize(new java.awt.Dimension(28, 35));
		MinimumSwitch.setSize(new java.awt.Dimension(28, 35));
		MinimumSwitch.setFocusPainted(false);
		MinimumSwitch.setDoubleBuffered(true);
		MinimumSwitch.setHorizontalTextPosition(0);
		MinimumSwitch.setDisabledIcon(switch_off);
		MinimumSwitch.setToolTipText("Whether species extinction is based on energy or population size");

		PoolVarSwitch.setLocation(new java.awt.Point(550, 280));
		PoolVarSwitch.setContentAreaFilled(false);
		PoolVarSwitch.setVisible(true);
		PoolVarSwitch.setBackground(new java.awt.Color(0, 0, 0));
		PoolVarSwitch.setBorderPainted(false);
		PoolVarSwitch.setMinimumSize(new java.awt.Dimension(28, 35));
		PoolVarSwitch.setSize(new java.awt.Dimension(28, 35));
		PoolVarSwitch.setFocusPainted(false);
		PoolVarSwitch.setDoubleBuffered(true);
		PoolVarSwitch.setHorizontalTextPosition(0);
		PoolVarSwitch.setDisabledIcon(switch_off);
		PoolVarSwitch.setToolTipText("Whether new-species pool has constant Y-variance");
		
		EXSwitch.setLocation(new java.awt.Point(550, 280));
		EXSwitch.setContentAreaFilled(false);
		EXSwitch.setVisible(true);
		EXSwitch.setBackground(new java.awt.Color(0, 0, 0));
		EXSwitch.setBorderPainted(false);
		EXSwitch.setMinimumSize(new java.awt.Dimension(28, 35));
		EXSwitch.setSize(new java.awt.Dimension(28, 35));
		EXSwitch.setFocusPainted(false);
		EXSwitch.setDoubleBuffered(true);
		EXSwitch.setHorizontalTextPosition(0);
		EXSwitch.setDisabledIcon(switch_off);
		
		EValueSwitch.setLocation(new java.awt.Point(550, 340));
		EValueSwitch.setContentAreaFilled(false);
		EValueSwitch.setVisible(true);
		EValueSwitch.setBackground(new java.awt.Color(0, 0, 0));
		EValueSwitch.setBorderPainted(false);
		EValueSwitch.setMinimumSize(new java.awt.Dimension(28, 35));
		EValueSwitch.setSize(new java.awt.Dimension(28, 35));
		EValueSwitch.setFocusPainted(false);
		EValueSwitch.setDoubleBuffered(true);
		EValueSwitch.setHorizontalTextPosition(0);
		EValueSwitch.setDisabledIcon(switch_off);
		EValueSwitch.setToolTipText("Adds small random component to energy increment");

		TimestepNumberLabel.setText("30");
		TimestepNumberLabel.setForeground(new java.awt.Color(255, 255, 255));
		TimestepNumberLabel.setLocation(new java.awt.Point(6, 330));
		TimestepNumberLabel.setVisible(true);
		TimestepNumberLabel.setFont(new java.awt.Font("Helvetica", 1, 9));
		TimestepNumberLabel.setSize(new java.awt.Dimension(30, 10));

		TimestepsLabel.setText("NUMBER OF TIMESTEPS");
		TimestepsLabel.setForeground(new java.awt.Color(255, 255, 255));
		TimestepsLabel.setLocation(new java.awt.Point(53, 298));
		TimestepsLabel.setVisible(true);
		TimestepsLabel.setFont(new java.awt.Font("SansSerif", 0, 9));
		TimestepsLabel.setSize(new java.awt.Dimension(117, 12));

		jLabel3.setText("POWER");
		jLabel3.setForeground(new java.awt.Color(255, 255, 255));
		jLabel3.setLocation(new java.awt.Point(490, 70));
		jLabel3.setVisible(true);
		jLabel3.setSize(new java.awt.Dimension(50, 10));

		PantherionLabel.setLocation(new java.awt.Point(370, 20));
		PantherionLabel.setVisible(true);
		PantherionLabel.setSize(new java.awt.Dimension(90, 80));

		PowerLight.setRequestFocusEnabled(false);
		PowerLight.setForeground(new java.awt.Color(0, 0, 0));
		PowerLight.setLocation(new java.awt.Point(550, 20));
		PowerLight.setVisible(true);
		PowerLight.setBackground(new java.awt.Color(0, 0, 0));
		PowerLight.setOpaque(false);
		PowerLight.setSize(new java.awt.Dimension(53, 53));
		PowerLight.setHorizontalAlignment(SwingConstants.CENTER);
		PowerLight.setToolTipText("Red when device is powered");
		
		PFSlopeSlider.setForeground(new java.awt.Color(255, 255, 255));
		PFSlopeSlider.setLocation(new java.awt.Point(400, 440));
		PFSlopeSlider.setVisible(true);
		PFSlopeSlider.setBackground(new java.awt.Color(0, 0, 0));
		PFSlopeSlider.setValue(0);
		PFSlopeSlider.setPaintTicks(true);
		PFSlopeSlider.setSize(new java.awt.Dimension(120, 30));
		PFSlopeSlider.setMajorTickSpacing(25);


		EnergySlider.setForeground(new java.awt.Color(255, 255, 255));
		EnergySlider.setLocation(new java.awt.Point(400, 260));
		EnergySlider.setVisible(true);
		EnergySlider.setBackground(new java.awt.Color(0, 0, 0));
		EnergySlider.setValue(20);
		EnergySlider.setPaintTicks(true);
		EnergySlider.setSize(new java.awt.Dimension(120, 30));
		EnergySlider.setMajorTickSpacing(20);
		EnergySlider.setToolTipText("Value of per-capita evolutionary advance");


		AdvancingSlider.setForeground(new java.awt.Color(255, 255, 255));
		AdvancingSlider.setLocation(new java.awt.Point(400, 200));
		AdvancingSlider.setVisible(true);
		AdvancingSlider.setBackground(new java.awt.Color(0, 0, 0));
		AdvancingSlider.setValue(30);
		AdvancingSlider.setPaintTicks(true);
		AdvancingSlider.setSize(new java.awt.Dimension(120, 30));
		AdvancingSlider.setMajorTickSpacing(20);
		AdvancingSlider.setToolTipText("Expected number of advances per timestep");

		CompetitionSlider.setForeground(new java.awt.Color(255, 255, 255));
		CompetitionSlider.setLocation(new java.awt.Point(580, 470));
		CompetitionSlider.setVisible(true);
		CompetitionSlider.setBackground(new java.awt.Color(0, 0, 0));
		CompetitionSlider.setValue(0);
		CompetitionSlider.setPaintTicks(true);
		CompetitionSlider.setSize(new java.awt.Dimension(120, 30));
		CompetitionSlider.setMajorTickSpacing(25);

		ExtinctionLimitSlider.setForeground(new java.awt.Color(255, 255, 255));
		ExtinctionLimitSlider.setLocation(new java.awt.Point(400, 380));
		ExtinctionLimitSlider.setVisible(true);
		ExtinctionLimitSlider.setBackground(new java.awt.Color(0, 0, 0));
		ExtinctionLimitSlider.setValue(1);
		ExtinctionLimitSlider.setPaintTicks(true);
		ExtinctionLimitSlider.setSize(new java.awt.Dimension(120, 30));
		ExtinctionLimitSlider.setMajorTickSpacing(25);
		ExtinctionLimitSlider.setToolTipText("Minimum population size at which a species will go extinct");

		VideoModeSwitch.setLocation(new java.awt.Point(10, 240));
		VideoModeSwitch.setContentAreaFilled(false);
		VideoModeSwitch.setVisible(true);
		VideoModeSwitch.setBackground(new java.awt.Color(0, 0, 0));
		VideoModeSwitch.setBorderPainted(false);
		VideoModeSwitch.setMinimumSize(new java.awt.Dimension(28, 35));
		VideoModeSwitch.setSize(new java.awt.Dimension(28, 35));
		VideoModeSwitch.setFocusPainted(false);
		VideoModeSwitch.setDoubleBuffered(true);
		VideoModeSwitch.setHorizontalTextPosition(0);
		VideoModeSwitch.setDisabledIcon(switch_off);
		VideoModeSwitch.setToolTipText("Toggles views of slope trajectories or regressions");
		
		AnalysisModeSwitch.setLocation(new java.awt.Point(10, 140));
		AnalysisModeSwitch.setContentAreaFilled(false);
		AnalysisModeSwitch.setVisible(true);
		AnalysisModeSwitch.setBackground(new java.awt.Color(0, 0, 0));
		AnalysisModeSwitch.setBorderPainted(false);
		AnalysisModeSwitch.setMinimumSize(new java.awt.Dimension(28, 35));
		AnalysisModeSwitch.setSize(new java.awt.Dimension(28, 35));
		AnalysisModeSwitch.setFocusPainted(false);
		AnalysisModeSwitch.setDoubleBuffered(true);
		AnalysisModeSwitch.setHorizontalTextPosition(0);
		AnalysisModeSwitch.setDisabledIcon(switch_off);

		FaunasLabel.setText("NUMBER OF FAUNAS");
		FaunasLabel.setForeground(new java.awt.Color(255, 255, 255));
		FaunasLabel.setLocation(new java.awt.Point(43, 360));
		FaunasLabel.setVisible(true);
		FaunasLabel.setFont(new java.awt.Font("SansSerif", 0, 9));
		FaunasLabel.setSize(new java.awt.Dimension(117, 12));

		FaunasNumberLabel.setText("10");
		FaunasNumberLabel.setForeground(new java.awt.Color(255, 255, 255));
		FaunasNumberLabel.setLocation(new java.awt.Point(10, 392));
		FaunasNumberLabel.setVisible(true);
		FaunasNumberLabel.setFont(new java.awt.Font("Helvetica", 1, 9));
		FaunasNumberLabel.setSize(new java.awt.Dimension(30, 10));

		Ylabel.setText("INITIAL Y-VARIANCE");
		Ylabel.setForeground(new java.awt.Color(255, 255, 255));
		Ylabel.setLocation(new java.awt.Point(223, 300));
		Ylabel.setVisible(true);
		Ylabel.setFont(new java.awt.Font("SansSerif", 0, 9));
		Ylabel.setSize(new java.awt.Dimension(117, 12));

		YnumberLabel.setText("0.25");
		YnumberLabel.setForeground(new java.awt.Color(255, 255, 255));
		YnumberLabel.setLocation(new java.awt.Point(190, 330));
		YnumberLabel.setVisible(true);
		YnumberLabel.setFont(new java.awt.Font("Helvetica", 1, 9));
		YnumberLabel.setSize(new java.awt.Dimension(40, 18));

		SpeciesLabel.setText("NUMBER OF SPECIES");
		SpeciesLabel.setForeground(new java.awt.Color(255, 255, 255));
		SpeciesLabel.setLocation(new java.awt.Point(43, 420));
		SpeciesLabel.setVisible(true);
		SpeciesLabel.setFont(new java.awt.Font("SansSerif", 0, 9));
		SpeciesLabel.setSize(new java.awt.Dimension(117, 12));

		SSpeciesNumberLabel.setText("120");
		SSpeciesNumberLabel.setForeground(new java.awt.Color(255, 255, 255));
		SSpeciesNumberLabel.setLocation(new java.awt.Point(10, 452));
		SSpeciesNumberLabel.setVisible(true);
		SSpeciesNumberLabel.setFont(new java.awt.Font("Helvetica", 1, 9));
		SSpeciesNumberLabel.setSize(new java.awt.Dimension(30, 10));

		EtotLabel.setText("TOTAL ENERGY 10^x");
		EtotLabel.setForeground(new java.awt.Color(255, 255, 255));
		EtotLabel.setLocation(new java.awt.Point(403, 420));
		EtotLabel.setVisible(true);
		EtotLabel.setFont(new java.awt.Font("SansSerif", 0, 9));
		EtotLabel.setSize(new java.awt.Dimension(117, 12));

		EtotNumberLabel.setText("7");
		EtotNumberLabel.setForeground(new java.awt.Color(255, 255, 255));
		EtotNumberLabel.setLocation(new java.awt.Point(360, 452));
		EtotNumberLabel.setVisible(true);
		EtotNumberLabel.setFont(new java.awt.Font("Helvetica", 1, 9));
		EtotNumberLabel.setSize(new java.awt.Dimension(30, 10));

		MaxSlopeLabel.setText("MAXIMUM SLOPE");
		MaxSlopeLabel.setForeground(new java.awt.Color(255, 255, 255));
		MaxSlopeLabel.setLocation(new java.awt.Point(223, 360));
		MaxSlopeLabel.setVisible(true);
		MaxSlopeLabel.setFont(new java.awt.Font("SansSerif", 0, 9));
		MaxSlopeLabel.setSize(new java.awt.Dimension(117, 12));

		MaxSlopeNumberLabel.setText("-0.35");
		MaxSlopeNumberLabel.setForeground(new java.awt.Color(255, 255, 255));
		MaxSlopeNumberLabel.setLocation(new java.awt.Point(180, 392));
		MaxSlopeNumberLabel.setVisible(true);
		MaxSlopeNumberLabel.setFont(new java.awt.Font("Helvetica", 1, 9));
		MaxSlopeNumberLabel.setSize(new java.awt.Dimension(40, 18));

		MinSlopeLabel.setText("MINIMUM SLOPE");
		MinSlopeLabel.setForeground(new java.awt.Color(255, 255, 255));
		MinSlopeLabel.setLocation(new java.awt.Point(223, 420));
		MinSlopeLabel.setVisible(true);
		MinSlopeLabel.setFont(new java.awt.Font("SansSerif", 0, 9));
		MinSlopeLabel.setSize(new java.awt.Dimension(117, 12));

		MinSlopeNumberLabel.setText("-1.15");
		MinSlopeNumberLabel.setForeground(new java.awt.Color(255, 255, 255));
		MinSlopeNumberLabel.setLocation(new java.awt.Point(180, 452));
		MinSlopeNumberLabel.setVisible(true);
		MinSlopeNumberLabel.setFont(new java.awt.Font("Helvetica", 1, 9));
		MinSlopeNumberLabel.setSize(new java.awt.Dimension(40, 10));

		AcquisitionLabel.setText("ACQUISITION MULTIPLE");
		AcquisitionLabel.setForeground(new java.awt.Color(255, 255, 255));
		AcquisitionLabel.setLocation(new java.awt.Point(403, 300));
		AcquisitionLabel.setVisible(true);
		AcquisitionLabel.setFont(new java.awt.Font("SansSerif", 0, 9));
		AcquisitionLabel.setSize(new java.awt.Dimension(117, 12));

		AcquisitionNumberLabel.setText("1.00");
		AcquisitionNumberLabel.setForeground(new java.awt.Color(255, 255, 255));
		AcquisitionNumberLabel.setLocation(new java.awt.Point(360, 332));
		AcquisitionNumberLabel.setVisible(true);
		AcquisitionNumberLabel.setFont(new java.awt.Font("Helvetica", 1, 9));
		AcquisitionNumberLabel.setSize(new java.awt.Dimension(40, 10));

		BasePFLabel.setText("BASE PF");
		BasePFLabel.setForeground(new java.awt.Color(255, 255, 255));
		BasePFLabel.setLocation(new java.awt.Point(403, 360));
		BasePFLabel.setVisible(true);
		BasePFLabel.setFont(new java.awt.Font("SansSerif", 0, 9));
		BasePFLabel.setSize(new java.awt.Dimension(117, 12));

		BasePFNumberLabel.setText("1.00");
		BasePFNumberLabel.setForeground(new java.awt.Color(255, 255, 255));
		BasePFNumberLabel.setLocation(new java.awt.Point(360, 392));
		BasePFNumberLabel.setVisible(true);
		BasePFNumberLabel.setFont(new java.awt.Font("Helvetica", 1, 9));
		BasePFNumberLabel.setSize(new java.awt.Dimension(40, 10));

		PFSlopeLabel.setText("PF SLOPE");
		PFSlopeLabel.setForeground(new java.awt.Color(255, 255, 255));
		PFSlopeLabel.setLocation(new java.awt.Point(403, 420));
		PFSlopeLabel.setVisible(true);
		PFSlopeLabel.setFont(new java.awt.Font("SansSerif", 0, 9));
		PFSlopeLabel.setSize(new java.awt.Dimension(117, 12));

		PFSlopeNumberLabel.setText("0");
		PFSlopeNumberLabel.setForeground(new java.awt.Color(255, 255, 255));
		PFSlopeNumberLabel.setLocation(new java.awt.Point(370, 452));
		PFSlopeNumberLabel.setVisible(true);
		PFSlopeNumberLabel.setFont(new java.awt.Font("Helvetica", 1, 9));
		PFSlopeNumberLabel.setSize(new java.awt.Dimension(30, 10));

		ExtinctionLabel.setText("EXTINCTION LIMIT (D)");
		ExtinctionLabel.setForeground(new java.awt.Color(255, 255, 255));
		ExtinctionLabel.setLocation(new java.awt.Point(403, 360));
		ExtinctionLabel.setVisible(true);
		ExtinctionLabel.setFont(new java.awt.Font("SansSerif", 0, 9));
		ExtinctionLabel.setSize(new java.awt.Dimension(117, 12));

		ExtinctionNumberLabel.setText("1");
		ExtinctionNumberLabel.setForeground(new java.awt.Color(255, 255, 255));
		ExtinctionNumberLabel.setLocation(new java.awt.Point(360, 392));
		ExtinctionNumberLabel.setVisible(true);
		ExtinctionNumberLabel.setFont(new java.awt.Font("Helvetica", 1, 9));
		ExtinctionNumberLabel.setSize(new java.awt.Dimension(40, 10));

		CompetitionLabel.setText("RANGE OF COMPETITION (LOG)");
		CompetitionLabel.setForeground(new java.awt.Color(255, 255, 255));
		CompetitionLabel.setLocation(new java.awt.Point(560, 450));
		CompetitionLabel.setVisible(true);
		CompetitionLabel.setFont(new java.awt.Font("SansSerif", 0, 9));
		CompetitionLabel.setSize(new java.awt.Dimension(140, 20));

		CompetitionNumberLabel.setText("0");
		CompetitionNumberLabel.setForeground(new java.awt.Color(255, 255, 255));
		CompetitionNumberLabel.setLocation(new java.awt.Point(540, 480));
		CompetitionNumberLabel.setVisible(true);
		CompetitionNumberLabel.setFont(new java.awt.Font("Helvetica", 1, 9));
		CompetitionNumberLabel.setSize(new java.awt.Dimension(40, 10));

		AdvancingLabel.setText("SPECIES ADVANCING (%)");
		AdvancingLabel.setForeground(new java.awt.Color(255, 255, 255));
		AdvancingLabel.setLocation(new java.awt.Point(400, 180));
		AdvancingLabel.setVisible(true);
		AdvancingLabel.setFont(new java.awt.Font("SansSerif", 0, 9));
		AdvancingLabel.setSize(new java.awt.Dimension(117, 12));

		AdvancingNumberLabel.setText("30");
		AdvancingNumberLabel.setForeground(new java.awt.Color(255, 255, 255));
		AdvancingNumberLabel.setLocation(new java.awt.Point(370, 210));
		AdvancingNumberLabel.setVisible(true);
		AdvancingNumberLabel.setFont(new java.awt.Font("Helvetica", 1, 9));
		AdvancingNumberLabel.setSize(new java.awt.Dimension(40, 10));

		EnergyLabel.setText("ENERGY INCREMENT (%)");
		EnergyLabel.setForeground(new java.awt.Color(255, 255, 255));
		EnergyLabel.setLocation(new java.awt.Point(403, 240));
		EnergyLabel.setVisible(true);
		EnergyLabel.setFont(new java.awt.Font("SansSerif", 0, 9));
		EnergyLabel.setSize(new java.awt.Dimension(117, 12));

		EnergyNumberLabel.setText("2");
		EnergyNumberLabel.setForeground(new java.awt.Color(255, 255, 255));
		EnergyNumberLabel.setLocation(new java.awt.Point(370, 272));
		EnergyNumberLabel.setVisible(true);
		EnergyNumberLabel.setFont(new java.awt.Font("Helvetica", 1, 9));
		EnergyNumberLabel.setSize(new java.awt.Dimension(30, 10));

		univSwLabel.setText("Interactions");
		univSwLabel.setForeground(new java.awt.Color(255, 255, 255));
		univSwLabel.setLocation(new java.awt.Point(630, 110));
		univSwLabel.setVisible(true);
		univSwLabel.setFont(new java.awt.Font("SansSerif", 0, 10));
		univSwLabel.setSize(new java.awt.Dimension(60, 10));
		
		HardcapLabel.setText("Energy Cap");
		HardcapLabel.setForeground(new java.awt.Color(255, 255, 255));
		HardcapLabel.setLocation(new java.awt.Point(630, 170));
		HardcapLabel.setVisible(true);
		HardcapLabel.setFont(new java.awt.Font("SansSerif", 0, 10));
		HardcapLabel.setSize(new java.awt.Dimension(60, 15));

		PoolVarLabel.setText("POOL VARIANCE");
		PoolVarLabel.setForeground(new java.awt.Color(255, 255, 255));
		PoolVarLabel.setLocation(new java.awt.Point(630, 290));
		PoolVarLabel.setVisible(true);
		PoolVarLabel.setFont(new java.awt.Font("SansSerif", 0, 9));
		PoolVarLabel.setSize(new java.awt.Dimension(80, 15));

		jLabel28.setText("Minimum");
		jLabel28.setForeground(new java.awt.Color(255, 255, 255));
		jLabel28.setLocation(new java.awt.Point(630, 230));
		jLabel28.setVisible(true);
		jLabel28.setFont(new java.awt.Font("SansSerif", 0, 10));
		jLabel28.setSize(new java.awt.Dimension(60, 10));

		jLabel29.setText("E Exchange");
		jLabel29.setForeground(new java.awt.Color(255, 255, 255));
		jLabel29.setLocation(new java.awt.Point(630, 290));
		jLabel29.setVisible(true);
		jLabel29.setFont(new java.awt.Font("SansSerif", 0, 12));
		jLabel29.setSize(new java.awt.Dimension(70, 14));

		jLabel30.setText("E Value");
		jLabel30.setForeground(new java.awt.Color(255, 255, 255));
		jLabel30.setLocation(new java.awt.Point(630, 350));
		jLabel30.setVisible(true);
		jLabel30.setFont(new java.awt.Font("SansSerif", 0, 10));
		jLabel30.setSize(new java.awt.Dimension(50, 10));

		modeLabel.setText("VIDEO");
		modeLabel.setForeground(new java.awt.Color(255, 255, 255));
		modeLabel.setLocation(new java.awt.Point(10, 200));
		modeLabel.setVisible(true);
		modeLabel.setFont(new java.awt.Font("SansSerif", 0, 8));
		modeLabel.setSize(new java.awt.Dimension(30, 20));

		jLabel31.setText("MODE");
		jLabel31.setForeground(new java.awt.Color(255, 255, 255));
		jLabel31.setLocation(new java.awt.Point(10, 210));
		jLabel31.setVisible(true);
		jLabel31.setFont(new java.awt.Font("SansSerif", 0, 8));
		jLabel31.setSize(new java.awt.Dimension(30, 20));
		
		amLabel.setText("SEUD");
		amLabel.setForeground(new java.awt.Color(255, 255, 255));
		amLabel.setLocation(new java.awt.Point(10, 100));
		amLabel.setVisible(true);
		amLabel.setFont(new java.awt.Font("SansSerif", 0, 10));
		amLabel.setSize(new java.awt.Dimension(30, 20));

		voltageLabel.setText("110 V AC");
		voltageLabel.setForeground(new java.awt.Color(255, 255, 255));
		voltageLabel.setLocation(new java.awt.Point(500, 90));
		voltageLabel.setVisible(true);
		voltageLabel.setFont(new java.awt.Font("SansSerif", 0, 8));
		voltageLabel.setSize(new java.awt.Dimension(50, 10));
		voltageLabel.setToolTipText("Not really : )");

		openLabel.setText("NONE");
		openLabel.setForeground(new java.awt.Color(255, 255, 255));
		openLabel.setLocation(new java.awt.Point(590, 100));
		openLabel.setVisible(true);
		openLabel.setFont(new java.awt.Font("SansSerif", 0, 8));
		openLabel.setSize(new java.awt.Dimension(40, 10));

		closedLabel.setText("WIN-LOSE");
		closedLabel.setForeground(new java.awt.Color(255, 255, 255));
		closedLabel.setLocation(new java.awt.Point(590, 130));
		closedLabel.setVisible(true);
		closedLabel.setFont(new java.awt.Font("SansSerif", 0, 8));
		closedLabel.setSize(new java.awt.Dimension(40, 10));
		
		HardcapOn.setText("ON");
		HardcapOn.setForeground(new java.awt.Color(255, 255, 255));
		HardcapOn.setLocation(new java.awt.Point(590, 160));
		HardcapOn.setVisible(true);
		HardcapOn.setFont(new java.awt.Font("SansSerif", 0, 8));
		HardcapOn.setSize(new java.awt.Dimension(40, 10));

		HardcapOff.setText("OFF");
		HardcapOff.setForeground(new java.awt.Color(255, 255, 255));
		HardcapOff.setLocation(new java.awt.Point(590, 190));
		HardcapOff.setVisible(true);
		HardcapOff.setFont(new java.awt.Font("SansSerif", 0, 8));
		HardcapOff.setSize(new java.awt.Dimension(40, 10));
		
		PoolVarOn.setText("CONSTANT");
		PoolVarOn.setForeground(new java.awt.Color(255, 255, 255));
		PoolVarOn.setLocation(new java.awt.Point(590, 280));
		PoolVarOn.setVisible(true);
		PoolVarOn.setFont(new java.awt.Font("SansSerif", 0, 8));
		PoolVarOn.setSize(new java.awt.Dimension(45, 10));

		PoolVarOff.setText("VARIABLE");
		PoolVarOff.setForeground(new java.awt.Color(255, 255, 255));
		PoolVarOff.setLocation(new java.awt.Point(590, 310));
		PoolVarOff.setVisible(true);
		PoolVarOff.setFont(new java.awt.Font("SansSerif", 0, 8));
		PoolVarOff.setSize(new java.awt.Dimension(45, 10));
		
		StartButton.setIcon(startoffB);
		StartButton.setDisabledIcon(startoffB);
		StartButton.setLocation(new java.awt.Point(490, 120));
		StartButton.setVisible(true);
		StartButton.setSize(new java.awt.Dimension(38, 29));
		StartButton.setEnabled(false);
		StartButton.setToolTipText("Start the faunas running");

		StopButton.setIcon(stopoffB);
		StopButton.setDisabledIcon(stopoffB);
		StopButton.setLocation(new java.awt.Point(450, 120));
		StopButton.setVisible(true);
		StopButton.setSize(new java.awt.Dimension(38, 29));	
		StopButton.setEnabled(false);
		StopButton.setToolTipText("Cancel a run in progress");	

		SaveButton.setIcon(saveB);
		SaveButton.setDisabledIcon(saveoffB);
		SaveButton.setLocation(new java.awt.Point(8, 30));
		SaveButton.setVisible(true);
		SaveButton.setSize(new java.awt.Dimension(38, 29));
		SaveButton.setEnabled(false);
		SaveButton.setToolTipText("Save additional data or screen image");

		jLabel32.setText("DENSITY");
		jLabel32.setForeground(new java.awt.Color(255, 255, 255));
		jLabel32.setLocation(new java.awt.Point(590, 220));
		jLabel32.setVisible(true);
		jLabel32.setFont(new java.awt.Font("SansSerif", 0, 8));
		jLabel32.setSize(new java.awt.Dimension(40, 10));

		jLabel33.setText("ENERGY");
		jLabel33.setForeground(new java.awt.Color(255, 255, 255));
		jLabel33.setLocation(new java.awt.Point(590, 250));
		jLabel33.setVisible(true);
		jLabel33.setFont(new java.awt.Font("SansSerif", 0, 8));
		jLabel33.setSize(new java.awt.Dimension(40, 10));

		jLabel34.setText("PROPORTION");
		jLabel34.setForeground(new java.awt.Color(255, 255, 255));
		jLabel34.setLocation(new java.awt.Point(590, 280));
		jLabel34.setVisible(true);
		jLabel34.setFont(new java.awt.Font("SansSerif", 0, 8));
		jLabel34.setSize(new java.awt.Dimension(60, 10));

		jLabel35.setText("CONSTANT");
		jLabel35.setForeground(new java.awt.Color(255, 255, 255));
		jLabel35.setLocation(new java.awt.Point(590, 310));
		jLabel35.setVisible(true);
		jLabel35.setFont(new java.awt.Font("SansSerif", 0, 8));
		jLabel35.setSize(new java.awt.Dimension(50, 10));

		jLabel36.setText("RANDOM");
		jLabel36.setForeground(new java.awt.Color(255, 255, 255));
		jLabel36.setLocation(new java.awt.Point(590, 340));
		jLabel36.setVisible(true);
		jLabel36.setFont(new java.awt.Font("SansSerif", 0, 8));
		jLabel36.setSize(new java.awt.Dimension(40, 10));

		jLabel37.setText("CONSTANT");
		jLabel37.setForeground(new java.awt.Color(255, 255, 255));
		jLabel37.setLocation(new java.awt.Point(590, 370));
		jLabel37.setVisible(true);
		jLabel37.setFont(new java.awt.Font("SansSerif", 0, 8));
		jLabel37.setSize(new java.awt.Dimension(50, 10));

		RunningLight.setRequestFocusEnabled(false);
		RunningLight.setForeground(new java.awt.Color(0, 0, 0));
		RunningLight.setLocation(new java.awt.Point(640, 20));
		RunningLight.setVisible(true);
		RunningLight.setBackground(new java.awt.Color(0, 0, 0));
		RunningLight.setOpaque(true);
		RunningLight.setSize(new java.awt.Dimension(52, 52));
		RunningLight.setHorizontalAlignment(SwingConstants.CENTER);
		RunningLight.setToolTipText("Green while a run is in progress");

		KleiberLabel.setText("KLEIBER SLOPE");
		KleiberLabel.setForeground(new java.awt.Color(255, 255, 255));
		KleiberLabel.setLocation(new java.awt.Point(403, 300));
		KleiberLabel.setVisible(true);
		KleiberLabel.setFont(new java.awt.Font("SansSerif", 0, 9));
		KleiberLabel.setSize(new java.awt.Dimension(117, 12));

		KleiberNumberLabel.setText("0.75");
		KleiberNumberLabel.setForeground(new java.awt.Color(255, 255, 255));
		KleiberNumberLabel.setLocation(new java.awt.Point(360, 330));
		KleiberNumberLabel.setVisible(true);
		KleiberNumberLabel.setFont(new java.awt.Font("Helvetica", 1, 9));
		KleiberNumberLabel.setSize(new java.awt.Dimension(40, 10));

		KleiberSlider.setForeground(new java.awt.Color(255, 255, 255));
		KleiberSlider.setLocation(new java.awt.Point(400, 320));
		KleiberSlider.setVisible(true);
		KleiberSlider.setBackground(new java.awt.Color(0, 0, 0));
		KleiberSlider.setValue(75);
		KleiberSlider.setMaximum(150);
		KleiberSlider.setPaintTicks(true);
		KleiberSlider.setSize(new java.awt.Dimension(120, 30));
		KleiberSlider.setMajorTickSpacing(25);
		KleiberSlider.setToolTipText("Change the metabolic scaling exponent");

		setLocation(new java.awt.Point(0, 0));
		setTitle("Red Queen Simulator");
		setBackground(java.awt.SystemColor.desktop);
		getContentPane().setLayout(null);
		setSize(new java.awt.Dimension(719, 586));
		
		// Some of the controls were included in early versions of
		//  the application, but were never used. Nevertheless, they
		//  have been retained in order to avoid breaking the code,
		//  with the associated variables set to inoperative values.
		//  Such inoperative controls are commented out below and
		//  simply do not appear in the finished application. Do not
		//  add them; they have not been gfully tested and the results
		//  will not be interpretable.
		
		
		getContentPane().add(TimestepsSlider);
		getContentPane().add(CRT);
		getContentPane().add(PowerSwitch);
		getContentPane().add(FaunasSlider);
		getContentPane().add(SpeciesSlider);
		getContentPane().add(EtotSlider);
		getContentPane().add(EtotLabel);
		getContentPane().add(EtotNumberLabel);
		getContentPane().add(YvarianceSlider);
		getContentPane().add(MaxSlopeSlider);
		getContentPane().add(MinSlopeSlider);
//		getContentPane().add(AcquisitionSlider);
//		getContentPane().add(BasePFSlider);
		getContentPane().add(UniverseSwitch);
		getContentPane().add(MinimumSwitch);
//		getContentPane().add(EXSwitch);
		getContentPane().add(EValueSwitch);
		getContentPane().add(TimestepNumberLabel);
		getContentPane().add(TimestepsLabel);
		getContentPane().add(jLabel3);
		getContentPane().add(PantherionLabel);
		getContentPane().add(PowerLight);
//		getContentPane().add(PFSlopeSlider);
		getContentPane().add(EnergySlider);
		getContentPane().add(AdvancingSlider);
//		getContentPane().add(CompetitionSlider);
		getContentPane().add(ExtinctionLimitSlider);
		getContentPane().add(VideoModeSwitch);
//		getContentPane().add(AnalysisModeSwitch);
		getContentPane().add(FaunasLabel);
		getContentPane().add(FaunasNumberLabel);
		getContentPane().add(Ylabel);
		getContentPane().add(YnumberLabel);
		getContentPane().add(SpeciesLabel);
		getContentPane().add(SSpeciesNumberLabel);
		getContentPane().add(MaxSlopeLabel);
		getContentPane().add(MaxSlopeNumberLabel);
		getContentPane().add(MinSlopeLabel);
		getContentPane().add(MinSlopeNumberLabel);
//		getContentPane().add(AcquisitionLabel);
//		getContentPane().add(AcquisitionNumberLabel);
//		getContentPane().add(BasePFLabel);
//		getContentPane().add(BasePFNumberLabel);
//		getContentPane().add(PFSlopeLabel);
//		getContentPane().add(PFSlopeNumberLabel);
		getContentPane().add(ExtinctionLabel);
		getContentPane().add(ExtinctionNumberLabel);
//		getContentPane().add(CompetitionLabel);
//		getContentPane().add(CompetitionNumberLabel);
		getContentPane().add(AdvancingLabel);
		getContentPane().add(AdvancingNumberLabel);
		getContentPane().add(EnergyLabel);
		getContentPane().add(EnergyNumberLabel);
		getContentPane().add(univSwLabel);
		getContentPane().add(jLabel28);
//		getContentPane().add(jLabel29);
		getContentPane().add(jLabel30);
		getContentPane().add(modeLabel);
//		getContentPane().add(amLabel);
		getContentPane().add(jLabel31);
		getContentPane().add(HardcapSwitch);
		getContentPane().add(HardcapLabel);
		getContentPane().add(HardcapOn);
		getContentPane().add(HardcapOff);
		getContentPane().add(PoolVarSwitch);
		getContentPane().add(PoolVarLabel);
		getContentPane().add(PoolVarOn);
		getContentPane().add(PoolVarOff);
		getContentPane().add(voltageLabel);
		getContentPane().add(openLabel);
		getContentPane().add(closedLabel);
		getContentPane().add(StartButton);
		getContentPane().add(SaveButton);
		getContentPane().add(StopButton);
		getContentPane().add(jLabel32);
		getContentPane().add(jLabel33);
//		getContentPane().add(jLabel34);
//		getContentPane().add(jLabel35);
		getContentPane().add(jLabel36);
		getContentPane().add(jLabel37);
		getContentPane().add(RunningLight);
		getContentPane().add(KleiberLabel);
		getContentPane().add(KleiberNumberLabel);
		getContentPane().add(KleiberSlider);


		addWindowListener(new java.awt.event.WindowAdapter() {
			public void windowClosing(java.awt.event.WindowEvent e) {
				thisWindowClosing(e);
			}
		});
		
		PowerSwitch.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
				PowerTripped(e);

			}
		});
		
		VideoModeSwitch.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
				VideoModeTripped(e);

			}
		});
		
		AnalysisModeSwitch.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
				AnalysisModeTripped(e);

			}
		});
		
		UniverseSwitch.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
				UniverseTripped(e);

			}
		});	
		
		HardcapSwitch.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
				HardcapTripped(e);

			}
		});	
			
		PoolVarSwitch.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
				PoolVarTripped(e);

			}
		});	
					
		
		MinimumSwitch.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
				MinimumTripped(e);

			}
		});		
		
		EXSwitch.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
				EXTripped(e);

			}
		});		
		

		EValueSwitch.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
				EValueTripped(e);

			}
		});
				
		
		TimestepsSlider.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				TimestepAdjusted(e);

			}
		});		

		FaunasSlider.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				FaunasAdjusted(e);

			}
		});
		
		SpeciesSlider.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				SpeciesAdjusted(e);

			}
		});	
		
		EtotSlider.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				EtotAdjusted(e);

			}
		});	
		
		
		YvarianceSlider.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				YvarianceSliderAdjusted(e);

			}
		});								 

		MaxSlopeSlider.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				MaxSlopeAdjusted(e);

			}
		});		

		MinSlopeSlider.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				MinSlopeAdjusted(e);

			}
		});	

		AcquisitionSlider.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				AcquisitionAdjusted(e);

			}
		});
		
		BasePFSlider.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				BasePFSliderAdjusted(e);

			}
		});			
		
		PFSlopeSlider.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				PFSlopeAdjusted(e);

			}
		});	
		
		EnergySlider.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				EnergyAdjusted(e);

			}
		});			

		AdvancingSlider.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				AdvancingAdjusted(e);

			}
		});	

		CompetitionSlider.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				CompetitionAdjusted(e);

			}
		});	
		
		ExtinctionLimitSlider.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				ExtinctionLimitSliderAdjusted(e);

			}
		});			
		
		KleiberSlider.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				KleiberAdjusted(e);

			}
		});			
		
		
		StartButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				StartPushed(e);

			}
		});				

		StopButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				StopPushed(e);

			}
		});				

		SaveButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				SavePushed(e);

			}
		});				



			
	}
  
  	private boolean mShown = false;
  	
	public void addNotify() 
	{
		super.addNotify();
		
		if (mShown)
			return;
			
		// resize frame to account for menubar
		JMenuBar jMenuBar = getJMenuBar();
		if (jMenuBar != null) {
			int jMenuBarHeight = jMenuBar.getPreferredSize().height;
			Dimension dimension = getSize();
			dimension.height += jMenuBarHeight;
			setSize(dimension);
		}

		mShown = true;
	}

	// Close the window when the close box is clicked
	void thisWindowClosing(java.awt.event.WindowEvent e)
	{
		setVisible(false);
		dispose();
		System.exit(0);
	}
	
	// The switches
	
	public void PowerTripped(ItemEvent e){
			if(PowerSwitch.getIcon() == switch_off){			
			PowerSwitch.setIcon(switch_on);
			activate_display();
			}
		else{
			PowerSwitch.setIcon(switch_off);
			deactivate_display();
			}
		}

	public void VideoModeTripped(ItemEvent e){
			SaveButton.setIcon(saveoffB);
			SaveButton.setEnabled(false);
			if(VideoModeSwitch.getIcon() == switch_off){			
			VideoModeSwitch.setIcon(switch_on);
			CRT.toggle_video(1, analysis_on); // Points view or seud view
			slope_view = false;
			}
		else{
			VideoModeSwitch.setIcon(switch_off);
			CRT.toggle_video(0, analysis_on); // Slope view or S Dev view
			slope_view = true;
			}
		}
		
	public void AnalysisModeTripped(ItemEvent e){
			SaveButton.setIcon(saveoffB);
			SaveButton.setEnabled(false);
			if(AnalysisModeSwitch.getIcon() == switch_off){			
			AnalysisModeSwitch.setIcon(switch_on);
			analysis_on = true;
			if(slope_view) CRT.toggle_video(0, analysis_on);
			else CRT.toggle_video(1, analysis_on);
			}
		else{
			AnalysisModeSwitch.setIcon(switch_off);
			analysis_on = false;
			if(slope_view) CRT.toggle_video(0, analysis_on);
			else CRT.toggle_video(1, analysis_on);
			}
		}
	
	public void UniverseTripped(ItemEvent e){  // On is No interactions, Off is Winner-Loser Red Queen interactions
			if(UniverseSwitch.getIcon() == switch_off){			
			UniverseSwitch.setIcon(switch_on);
			universe_open = true;
			}
		else{
			UniverseSwitch.setIcon(switch_off);
			universe_open = false;
			}
		}	
	
	public void HardcapTripped(ItemEvent e){				// Meaningful only with Universe Open (no interactions),
			if(HardcapSwitch.getIcon() == switch_off){		//  when it determines whether or not total energy is
			HardcapSwitch.setIcon(switch_on);				//  kept constant. Always constant for win-lose.
			hard_cap_open = true;
			}
		else{
			HardcapSwitch.setIcon(switch_off);
			hard_cap_open = false;
			}
		}	

	public void PoolVarTripped(ItemEvent e){ 
			if(PoolVarSwitch.getIcon() == switch_off){			
			PoolVarSwitch.setIcon(switch_on);
			poolvar_is_constant = true;
			}
		else{
			PoolVarSwitch.setIcon(switch_off);
			poolvar_is_constant = false;
			}
		}	

	public void MinimumTripped(ItemEvent e){
			if(MinimumSwitch.getIcon() == switch_off){			
			MinimumSwitch.setIcon(switch_on);
			minimum_is_density = true;
			}
		else{
			MinimumSwitch.setIcon(switch_off);
			minimum_is_density = false;
			}
		}		
	

	public void EXTripped(ItemEvent e){
			if(EXSwitch.getIcon() == switch_off){			
			EXSwitch.setIcon(switch_on);
			exchange_proportional = true;
			}
		else{
			EXSwitch.setIcon(switch_off);
			 exchange_proportional = false;
			}
		}	


	public void EValueTripped(ItemEvent e){
			if(EValueSwitch.getIcon() == switch_off){			
			EValueSwitch.setIcon(switch_on);
			evalue_random = true;
			}
		else{
			EValueSwitch.setIcon(switch_off);
			evalue_random = false;
			}
		}	

	
	// The sliders
	
	public void TimestepAdjusted(javax.swing.event.ChangeEvent e){
		TimestepNumberLabel.setText("" + TimestepsSlider.getValue());
		CRT.setTimesteps(TimestepsSlider.getValue());
		}
		
	public void FaunasAdjusted(javax.swing.event.ChangeEvent e){
		FaunasNumberLabel.setText("" + FaunasSlider.getValue());
		}
	public void SpeciesAdjusted(javax.swing.event.ChangeEvent e){
		SSpeciesNumberLabel.setText("" + SpeciesSlider.getValue());
		}
	public void EtotAdjusted(javax.swing.event.ChangeEvent e){
		EtotNumberLabel.setText("" + EtotSlider.getValue());
		}		
	public void YvarianceSliderAdjusted(javax.swing.event.ChangeEvent e){
		double yval = YvarianceSlider.getValue() *0.01;
		YnumberLabel.setText("" + yval);
		}	
	public void MaxSlopeAdjusted(javax.swing.event.ChangeEvent e){
		double sval = MaxSlopeSlider.getValue() * 0.01;
		MaxSlopeNumberLabel.setText("" + sval);
		}
	public void MinSlopeAdjusted(javax.swing.event.ChangeEvent e){
		double sval = MinSlopeSlider.getValue() * 0.01;
		MinSlopeNumberLabel.setText("" + sval);
		}		
	public void AcquisitionAdjusted(javax.swing.event.ChangeEvent e){
		double sval = AcquisitionSlider.getValue() * 0.1;
		AcquisitionNumberLabel.setText("" + sval);
		}
	public void BasePFSliderAdjusted(javax.swing.event.ChangeEvent e){
		double sval = (BasePFSlider.getValue() * 0.1) + 1.0;
		BasePFNumberLabel.setText("" + sval);
		}					
	public void PFSlopeAdjusted(javax.swing.event.ChangeEvent e){
		double sval = PFSlopeSlider.getValue() * 0.01;
		PFSlopeNumberLabel.setText("" + sval);
		}
	public void EnergyAdjusted(javax.swing.event.ChangeEvent e){
		double sval = EnergySlider.getValue() * 0.1;
		EnergyNumberLabel.setText("" + sval);
		}
	public void AdvancingAdjusted(javax.swing.event.ChangeEvent e){
		double sval = AdvancingSlider.getValue();
		AdvancingNumberLabel.setText("" + sval);
		}					
	public void CompetitionAdjusted(javax.swing.event.ChangeEvent e){
		double sval = CompetitionSlider.getValue() * 0.025;
		CompetitionNumberLabel.setText("" + sval);
		}			
	public void ExtinctionLimitSliderAdjusted(javax.swing.event.ChangeEvent e){
		double sval = ExtinctionLimitSlider.getValue() * 1.0;
		ExtinctionNumberLabel.setText("" + sval);
		}
	public void KleiberAdjusted(javax.swing.event.ChangeEvent e){
		double sval = KleiberSlider.getValue() * 0.01;
		KleiberNumberLabel.setText("" + sval);
		}				
		
	// Buttons
	
	ExecuteRunThread exrun;
	
	public void StartPushed(ActionEvent e){
		if(slope_view) CRT.clearSlopeView();
		RunningLight.setIcon(light_on_green);
		StartButton.setEnabled(false);
		StartButton.setIcon(startoffB);
		StopButton.setEnabled(true);
		StopButton.setIcon(stopB);
		SaveButton.setIcon(saveoffB);
		SaveButton.setEnabled(false);
		should_execute = true;
		exrun = new ExecuteRunThread(this);
		exrun.start();
		}
	public void StopPushed(ActionEvent e){
		RunningLight.setIcon(light_off);
		should_execute = false;
		StartButton.setEnabled(true);
		StartButton.setIcon(startB);
		StopButton.setEnabled(false);
		StopButton.setIcon(stopoffB);
		SaveButton.setIcon(saveoffB);
		SaveButton.setEnabled(false);
		}			
	public void SavePushed(ActionEvent e){
		JFileChooser savechoose = new JFileChooser();
		File cwd = new File(System.getProperty("user.dir"));
		savechoose.setCurrentDirectory(cwd);
		int result = savechoose.showSaveDialog(this);
		if(result == JFileChooser.APPROVE_OPTION){
			SaveButton.setIcon(saveoffB);
			SaveButton.setEnabled(false);
			File sf =  savechoose.getSelectedFile();
			exrun.currentRun.saveVideoData(sf);
			}
		}								
			
	public void activate_display(){

		PowerLight.setIcon(light_on_red);
		StartButton.setIcon(startB);
		SaveButton.setIcon(saveoffB);
		StopButton.setIcon(stopoffB);
		StartButton.setEnabled(true);
		StopButton.setEnabled(false);
		SaveButton.setEnabled(false);
		CRT.setTimesteps(TimestepsSlider.getValue());	
		CRT.turn_on_CRT();
		slope_view = true;			
		}	
	
	public void deactivate_display(){

		should_execute = false;
		PowerLight.setIcon(light_off);
		StartButton.setIcon(startoffB);
		SaveButton.setIcon(saveoffB);
		StopButton.setIcon(stopoffB);
		StartButton.setEnabled(false);
		StopButton.setEnabled(false);
		SaveButton.setEnabled(false);
		RunningLight.setIcon(light_off);		
		CRT.turn_off_CRT();	
		VideoModeSwitch.setIcon(switch_off);
		AnalysisModeSwitch.setIcon(switch_off);
		}		


	
}

